use serde::Serialize;

use super::render_context::RenderContext;
use crate::error::CustomError;
use crate::intermediate::IEntity;

use super::macros::render;

#[derive(Debug, Serialize)]
#[serde(tag = "type")]
#[serde(rename = "entity")]
pub(crate) struct RenderEntity {
    html: String,
}

render!(RenderEntity, IEntity, original, _render_context, {
    Ok(RenderEntity {
        html: original.html.clone(),
    })
});
