use serde::Serialize;

use super::render_context::RenderContext;
use crate::error::CustomError;
use crate::intermediate::ISrcBlock;

use super::macros::render;

#[derive(Debug, Serialize)]
#[serde(tag = "type")]
#[serde(rename = "src_block")]
pub(crate) struct RenderSrcBlock {
    lines: Vec<String>,
}

render!(RenderSrcBlock, ISrcBlock, original, _render_context, {
    Ok(RenderSrcBlock {
        lines: original.lines.clone(),
    })
});
