use serde::Serialize;

use super::render_context::RenderContext;
use crate::error::CustomError;
use crate::intermediate::ITable;

use super::macros::render;
use super::table_row::RenderTableRow;

#[derive(Debug, Serialize)]
#[serde(tag = "type")]
#[serde(rename = "table")]
pub(crate) struct RenderTable {
    children: Vec<RenderTableRow>,
}

render!(RenderTable, ITable, original, render_context, {
    let children = {
        let mut ret = Vec::new();
        for obj in original.children.iter() {
            ret.push(RenderTableRow::new(render_context.clone(), obj)?);
        }
        ret
    };

    Ok(RenderTable { children })
});
