use serde::Serialize;

use super::render_context::RenderContext;
use crate::error::CustomError;
use crate::intermediate::ITarget;

use super::macros::render;

#[derive(Debug, Serialize)]
#[serde(tag = "type")]
#[serde(rename = "target")]
pub(crate) struct RenderTarget {
    id: String,
}

render!(RenderTarget, ITarget, original, _render_context, {
    Ok(RenderTarget {
        id: original.id.clone(),
    })
});
