use super::macros::intermediate;

use super::IPlainListItem;
use crate::error::CustomError;

#[derive(Debug, Clone)]
pub(crate) struct IPlainList {
    pub(crate) list_type: organic::types::PlainListType,
    pub(crate) children: Vec<IPlainListItem>,
}

intermediate!(
    IPlainList,
    &'orig organic::types::PlainList<'parse>,
    original,
    registry,
    {
        let children = {
            let mut ret = Vec::new();
            for obj in original.children.iter() {
                ret.push(IPlainListItem::new(registry.clone(), obj).await?);
            }
            ret
        };

        Ok(IPlainList {
            list_type: original.list_type,
            children,
        })
    }
);
