use super::macros::intermediate;
use super::IObject;

use crate::error::CustomError;

#[derive(Debug, Clone)]
pub(crate) struct IStrikeThrough {
    pub(crate) children: Vec<IObject>,
}

intermediate!(
    IStrikeThrough,
    &'orig organic::types::StrikeThrough<'parse>,
    original,
    registry,
    {
        let children = {
            let mut ret = Vec::new();
            for obj in original.children.iter() {
                ret.push(IObject::new(registry.clone(), obj).await?);
            }
            ret
        };

        Ok(IStrikeThrough { children })
    }
);
